#include "spawn.h"

#include "..\algorithms.h"

#include "..\dllcore.cpp"
#include "..\datatypes.cpp"
#include "..\algorithms.cpp"
#include "..\player.cpp"
#include "..\commtypes.cpp"

#define UNASSIGNED 0xffff


//////// Bot list ////////

_linkedlist <botInfo> botlist;

botInfo *findBot(CALL_HANDLE handle)
{
	_listnode <botInfo> *parse = botlist.head;

	while (parse)
	{
		botInfo *item = parse->item;

		if (item->validate(handle))
			return item;

		parse = parse->next;
	}

	return 0;
}

///////////MY CODE////////////

PlayerTag* botInfo::ReturnTag(Player *p)//given a player, it returns thier tag
{
	PlayerTag *tag=NULL;
	for(_listnode <PlayerTag> *tl= taglist.head;tl;tl= tl->next)
	{
		if(p==tl->item->P) //if the names of the tag and the player matches
		{
			tag=tl->item;
			break;
		} 
	}
	return tag;//return the player
}

void botInfo::RemoveInsidePerson(PlayerTag *pt, Area *AreaNum) //Removes a player from inside title
{
	if(CheckInside(pt)) //make sure player is inside
	{
		String S; //sends mod commands
		Uint16 Num=AreaNum->title;
		pt->AreaNumber.kill(AreaNum); //get rid of the node, player has left the area

		for(_listnode <Obj> *ol=ObjLocations.head;ol;ol=ol->next) //cycle through locations
		{
			if(Num == ol->item->title) //find the area that the player was in
			{break;}
		}


		if(ol->item->Private) //used for private obj switching, ON or OFF
		{
			if(ol->item->On_Off) //Player left the area, switch it back to its original state
			{
				S = "*objon "; //object on command
			}
			else
			{
				S="*objoff "; //object off command
			}
			S += ol->item->objNum; //add on object number
			sendPrivate(pt->P,S.msg); //send command private, grabs player from their tag
		}
		else
		{
			if(!CheckAreaNumber(Num)) // Checks to see if there are players inside area
			{				
				if(ol->item->On_Off) //switch its state becuase everyone left
				{
					S = "*objoff "; //object off command
					ol->item->On_Off=false;
				}
				else
				{
					S="*objon "; //object on command
					ol->item->On_Off=true;
				}

				S += ol->item->objNum; //add on object number
				sendPublic(S.msg); //send command public
			}
		}
	}
}

bool botInfo::CheckInside(PlayerTag *pt) //Check if the person is in a obj area
{
	return (pt->AreaNumber.total > 0); //if the player is in more than 0 object areas, then return true
}

bool botInfo::CheckAreaNumber(Uint16 AreaNum) //Check for people in a specific obj area
{
	bool Inside=false; //return value
	for(_listnode <PlayerTag> *pt= taglist.head;pt;pt=pt->next) //look through taglist
	{
		for(_listnode <Area> *AreaNumber=pt->item->AreaNumber.head;AreaNumber;AreaNumber= AreaNumber->next)
		{
			if(AreaNumber->item->title == AreaNum) //if the area is already inhabited
			{
				Inside=true; //area occupied already. true
				break;
			}
		}
		if(Inside)
		{break;}
	}
	return Inside; //return area inhabited or not inhabited
}

void botInfo::BotEnable() //Turns on objects that begin in the ON state
{
	taglist.clear(); //In case of server recycle, clear all the players out of taglist
	ObjLocations.clear(); //In case of server recycle, need to clear linklist and reread file
	LoadObjAreas(); //Loads the obj areas from file	

	String S; //send commands 

	for(_listnode <Obj> *parseObj=ObjLocations.head;parseObj;parseObj=parseObj->next)
	{
		if(parseObj->item->On_Off) // Turn on a objects that start ON
		{
			S= "*objon "; //objon command
			S+= parseObj->item->objNum;// add its obj number
			sendPublic(S.msg); //send *objon signal
		}
	}

	for(_listnode <Player> *pl= playerlist->head;pl;pl=pl->next) 
	{
		if(pl->item->ship!=8)
		{
			AddInside(pl->item);
		}
	}
}

void botInfo::BotDisable() //Remove all players from inside area
{		
	for(_listnode <PlayerTag> *pt=taglist.head;pt;pt=taglist.head)
	{
		for(_listnode <Area> *AreaNumber=pt->item->AreaNumber.head;AreaNumber;AreaNumber=pt->item->AreaNumber.head)
		{
			RemoveInsidePerson(pt->item,AreaNumber->item); //remove and turn objects back to original position
		}
		pt->item->AreaNumber.clear();//make sure AreaNumber is clear and deallocated
		taglist.kill(pt);
	}
}

void botInfo::LoadObjAreas() //Load obj Areas from file
{
	char Path[512]; //File Path
	String title; //Obj's Title Number 
	GetCurrentDirectory(512, Path); //Grab Da Path
	strcat(Path, "\\objects.ini"); //concat with file

	char buffer[192];

	for (Uint16 i = 1; i <= 256; i++) //cycle through areas
	{
		title = "Obj"; //Object number in file
		title += i;

#define G(name) ZeroMemory(buffer, 192);\
		GetPrivateProfileString(title.msg, name, NULL, buffer, 192, Path)

#define G2(a) if (isNumeric(buffer))\
			a = getInteger(buffer, 10);\
		else\
			goto InvalidEntry

		G("FromX1");
		if (!buffer[0]) //Didnt grab anything, then continue to next obj
			continue;

		Obj *w = new Obj; //new obj to place in linkedlist
		w->Private=false;
		w->On_Off=false;

		G2(w->x1);

		G("FromY1");
		G2(w->y1);

		G("FromX2");
		G2(w->x2);

		G("FromY2");
		G2(w->y2);

		G("ObjStart");
		if(isNumeric(buffer) && getInteger(buffer, 10)>0)
		{w->On_Off=true;}

		G("SentPrivate");
		if(isNumeric(buffer) && getInteger(buffer, 10)>0)
		{w->Private=true;}

		G("ObjNum");
		G2(w->objNum);

		w->title=i; //title of the object, ex- [obj1]

		ObjLocations.append(w); //Place in list		

		continue;
InvalidEntry:
		String S; //Send error
		delete w;
		S = "Invalid objects.ini entry: ";
		S += i;
		tell(makeEcho(S.msg));
	}
}


//////// DLL "import" ////////

void botInfo::tell(BotEvent &event)
{
	if (callback && handle)
	{
		event.handle = handle;
		callback(event);
	}
}

void botInfo::gotEvent(BotEvent &event)
{
	if (CONNECTION_DENIED) return;

	switch (event.code)
	{
//////// Periodic ////////
	case EVENT_Tick:
		{
		}
		break;
//////// Arena ////////
	case EVENT_ArenaEnter:
		{
			arena = (char*)event.p[0];
			me = (Player*)event.p[1];	// if(me) {/*we are in the arena*/}
			bool biller_online = *(bool*)&event.p[2];

			if(Enabled)
			{BotEnable();} //Turn on objects that are in the ON state
		}
		break;
	case EVENT_ArenaSettings:
		{
			settings = (arenaSettings*)event.p[0];
		}
		break;
	case EVENT_ArenaLeave:
		{
			BotDisable(); //Disable bot, reset original state of objects
			me = 0;
		}
		break;
	case EVENT_ArenaListEntry:
		{
			char *name = (char*)event.p[0];
			bool current = *(bool*)&event.p[1];
			int population = *(int*)&event.p[2];
		}
		break;
	case EVENT_ArenaListEnd:
		{
			char *name = (char*)event.p[0];
			bool current = *(bool*)&event.p[1];
			int population = *(int*)&event.p[2];
		}
		break;
//////// Flag ////////
	case EVENT_FlagGrab:
		{
			Player *p = (Player*)event.p[0];
			Flag *f = (Flag*)event.p[1];
		}
		break;
	case EVENT_FlagDrop:
		{
			Player *p = (Player*)event.p[0];
		}
		break;
	case EVENT_FlagMove:
		{
			Flag *f = (Flag*)event.p[0];
		}
		break;
	case EVENT_FlagVictory:
		{
			int team = *(int*)&event.p[0];
			int reward = *(int*)&event.p[1];
		}
		break;
	case EVENT_FlagGameReset:
		{
		}
		break;
	case EVENT_FlagReward:
		{
			int team = *(int*)&event.p[0];
			int reward = *(int*)&event.p[1];
		}
		break;
//////// Timed ////////
	case EVENT_TimedGameOver:
		{
			Player *p[5];
			for (int i = 0; i < 5; i++)
				p[i] = (Player*)event.p[i];
		}
		break;
//////// Soccer ////////
	case EVENT_SoccerGoal:
		{
			int team = *(int*)&event.p[0];
			int reward = *(int*)&event.p[1];
		}
		break;
	case EVENT_BallMove:
		{
			PBall *ball = (PBall*)event.p[0];
		}
		break;
//////// File ////////
	case EVENT_File:
		{
			char *name = (char*)event.p[0];
		}
		break;
//////// Player ////////
	case EVENT_PlayerEntering:
		{
			Player *p = (Player*)event.p[0];
			if(p->ship != 8)
			{AddInside(p);}

			String Objon;
			for(_listnode <Obj> *ol=ObjLocations.head;ol;ol=ol->next)
			{
				if(ol->item->On_Off)
				{
					Objon="*objon ";
					Objon+=ol->item->objNum;
					sendPrivate(p,Objon);
				}
			}
		}
		break;
	case EVENT_PlayerMove:
		{
			Player *p = (Player*)event.p[0];
			
		if(Enabled && p!=me) //if the bot is enabled
		{	
			_listnode <Obj> *parseObj = ObjLocations.head; // Holds All the obj locations
			PlayerTag *pt= ReturnTag(p); //grab the player's tag

			
			if(pt!=NULL) //should never happen that pt==NULL, but just in case
			if (!CheckInside(pt)) //if player isnt inside obj area
			{
				while (parseObj) //Scroll through obj locations
				{
					if (p->tile.x > parseObj->item->x1 && p->tile.x < parseObj->item->x2 && p->tile.y > parseObj->item->y1 && p->tile.y < parseObj->item->y2)
					{ 	//check if they entered a obj area
						String S;//sends commands
						Area *NewArea=new Area; //allocate memory for new obj area
						NewArea->title= parseObj->item->title;//assign a number to it

						if(parseObj->item->Private) //used for private obj switching, ON or OFF
						{
							if(parseObj->item->On_Off) //they have entered area, turn on obj
							{
								S = "*objoff "; //object off command
							}
							else
							{
								S="*objon "; //object on command
							}
							S += parseObj->item->objNum; //add on object number
							sendPrivate(p,S.msg); //send command
						}
						else //used for normal obj switching, ON or OFF
						{
							if(!CheckAreaNumber(NewArea->title)) //Is anyone already in the obj area??
							{  
								if(parseObj->item->On_Off) //No one in obj area, switch its state for new person
								{
									S = "*objoff "; //object off command
									parseObj->item->On_Off=false;
								}
								else
								{
									S="*objon "; //object on command
									parseObj->item->On_Off=true;
								}
								S += parseObj->item->objNum; //add on object number
								sendPublic(S.msg); //send command
							}
						}
						pt->AreaNumber.append(NewArea); //place in areas that tha player is in
					}
					parseObj = parseObj->next; //go to next positions in list
				}
			}
			else //if the player was inside obj area, see if they are still there
			{
				while (parseObj) //cycle through locations
				{
					for(_listnode <Area> *AreaNumber=pt->AreaNumber.head;AreaNumber;AreaNumber= AreaNumber->next)
					{
						if(AreaNumber->item->title == parseObj->item->title) //if the area the player is in and the ObjLocation match
						{
							if (!(p->tile.x > parseObj->item->x1 && p->tile.x < parseObj->item->x2 && p->tile.y > parseObj->item->y1 && p->tile.y < parseObj->item->y2))
							{ //if they left the obj area they were previously in
								RemoveInsidePerson(pt,AreaNumber->item);//remove them from inside of obj area list
							}
							break;
						}
					}
					parseObj = parseObj->next;//go to next positions in list
				}
	
			}
		}
		}
		break;
	case EVENT_PlayerWeapon:
		{
			Player *p = (Player*)event.p[0];
			weaponInfo wi;
			wi.n = *(Uint16*)&event.p[1];
		}
		break;
	case EVENT_WatchDamage:
		{
			Player *p = (Player*)event.p[0];	// player
			Player *k = (Player*)event.p[1];	// attacker
			weaponInfo wi;
			wi.n = *(Uint16*)&event.p[2];
			Uint16 energy = *(Uint16*)&event.p[3];
			Uint16 damage = *(Uint16*)&event.p[4];
		}
		break;
	case EVENT_PlayerDeath:
		{
			Player *p = (Player*)event.p[0],
				   *k = (Player*)event.p[1];
			Uint16 bounty = (Uint16)event.p[2];
		}
		break;
	case EVENT_PlayerScore:
		{
			Player *p = (Player*)event.p[0];
		}
		break;
	case EVENT_PlayerPrize:
		{
			Player *p = (Player*)event.p[0];
			int prize = *(int *)&event.p[1];
		}
		break;
	case EVENT_PlayerShip:
		{
			Player *p = (Player*)event.p[0];
			Uint16 oldship = (Uint16)event.p[1];
			Uint16 oldteam = (Uint16)event.p[2];

			if(oldship == 8)
			{AddInside(p);}
		}
		break;
	case EVENT_PlayerSpec:
		{
			Player *p = (Player*)event.p[0];
			Uint16 oldteam = (Uint16)event.p[1];
			Uint16 oldship = (Uint16)event.p[2];
			
			if(Enabled)
			{
				PlayerTag *pt= ReturnTag(p); //grab player's tag
				for(_listnode <Area> *AreaNumber=pt->AreaNumber.head;AreaNumber;AreaNumber= pt->AreaNumber.head)
				{
					RemoveInsidePerson(pt,AreaNumber->item); //remove each obj location from tag
				}
				pt->AreaNumber.clear();//make sure AreaNumber is clear and deallocated
				taglist.kill(pt); //delete player from taglist
			} 
		}
		break;
	case EVENT_PlayerTeam:
		{
			Player *p = (Player*)event.p[0];
			Uint16 oldteam = (Uint16)event.p[1];
			Uint16 oldship = (Uint16)event.p[2];
		}
		break;
	case EVENT_PlayerLeaving:
		{
			Player *p = (Player*)event.p[0];
			gotEvent(makePlayerSpec(p, p->team, p->ship));
		}
		break;
//////// Selfish ////////
	case EVENT_SelfShipReset:
		{
		}
		break;
	case EVENT_SelfPrize:
		{
			Uint16 prize = (Uint16)event.p[0];
			Uint16 count = (Uint16)event.p[1];
		}
		break;
	case EVENT_SelfUFO:
		{
		}
		break;
	case EVENT_PositionHook:
		{
		}
		break;
//////// Bricks ////////
	case EVENT_BrickDropped:
		{
			int x1 = *(int*)&event.p[0];
			int y1 = *(int*)&event.p[1];
			int x2 = *(int*)&event.p[2];
			int y2 = *(int*)&event.p[3];
			int team = *(int*)&event.p[4];
		}
		break;
//////// LVZ ////////
	case EVENT_ObjectToggled:
		{
			objectInfo obj;
			obj.n = (Uint16)event.p[0];
		}
		break;
//////// Turret ////////
	case EVENT_CreateTurret:
		{
			Player *turreter = (Player*)event.p[0];
			Player *turretee = (Player*)event.p[1];
		}
		break;
	case EVENT_DeleteTurret:
		{
			Player *turreter = (Player*)event.p[0];
			Player *turretee = (Player*)event.p[1];
		}
		break;
//////// Chat ////////
	case EVENT_Chat:
		{
			int type  = *(int*)&event.p[0];
			int sound = *(int*)&event.p[1];
			Player *p = (Player*)event.p[2];
			char *msg = (char*)event.p[3];

			switch (type)
			{
			case MSG_Arena:
				{
				}
				break;
			case MSG_PublicMacro:		if (!p) break;
				{
				}
				break;
			case MSG_Public:			if (!p) break;
				{
				}
				break;
			case MSG_Team:				if (!p) break;
				{
				}
				break;
			case MSG_TeamPrivate:		if (!p) break;
				{
				}
				break;
			case MSG_Private:			if (!p) break;
				{
				}
				break;
			case MSG_PlayerWarning:		if (!p) break;
				{
				}
				break;
			case MSG_RemotePrivate:
				{
				}
				break;
			case MSG_ServerError:
				{
				}
				break;
			case MSG_Channel:
				{
				}
				break;
			};
		}
		break;
	case EVENT_LocalCommand:
		{
			Player *p = (Player*)event.p[0];
			Command *c = (Command*)event.p[1];

			gotCommand(p, c);
		}
		break;
	case EVENT_LocalHelp:
		{
			Player *p = (Player*)event.p[0];
			Command *c = (Command*)event.p[1];

			gotHelp(p, c);
		}
		break;
	case EVENT_RemoteCommand:
		{
			char *p = (char*)event.p[0];
			Command *c = (Command*)event.p[1];
			Operator_Level o = *(Operator_Level*)&event.p[2];

			gotRemote(p, c, o);
		}
		break;
	case EVENT_RemoteHelp:
		{
			char *p = (char*)event.p[0];
			Command *c = (Command*)event.p[1];
			Operator_Level o = *(Operator_Level*)&event.p[2];

			gotRemoteHelp(p, c, o);
		}
		break;
//////// Containment ////////
	case EVENT_Init:
		{
			int major	= HIWORD(*(int*)&event.p[0]);
			int minor	= LOWORD(*(int*)&event.p[0]);
			callback	= (CALL_COMMAND)event.p[1];
			playerlist	= (CALL_PLIST)event.p[2];
			flaglist	= (CALL_FLIST)event.p[3];
			map			= (CALL_MAP)event.p[4];
			bricklist	= (CALL_BLIST)event.p[5];

			if (major > CORE_MAJOR_VERSION)
			{
				tell(makeEcho("DLL plugin cannot connect.  This plugin is out of date."));

				CONNECTION_DENIED = true;

				return;
			}
			else if ((major < CORE_MAJOR_VERSION) || (minor < CORE_MINOR_VERSION))
			{
				tell(makeEcho("DLL plugin cannot connect.  This plugin requires the latest version of MERVBot."));

				CONNECTION_DENIED = true;

				return;
			}
			else
				tell(makeEcho("DLL plugin connected."));
		}
		break;
	case EVENT_Term:
		{
			tell(makeEcho("DLL plugin disconnected."));
		}
		break;
	};
}


//////// DLL export ////////

_declspec(dllexport) void __stdcall talk(BotEvent &event)
{
	botInfo *bot;

	bot = findBot(event.handle);

	if (!bot)
	{
		bot = new botInfo(event.handle);
		botlist.append(bot);
	}

	if (bot) bot->gotEvent(event);
}


//////// Chatter ////////

void botInfo::sendPrivate(Player *player, BYTE snd, char *msg)
{
	tell(makeSay(MSG_Private, snd, player->ident, msg));
}

void botInfo::sendPrivate(Player *player, char *msg)
{
	tell(makeSay(MSG_Private, 0, player->ident, msg));
}

void botInfo::sendTeam(char *msg)
{
	tell(makeSay(MSG_Team, 0, 0, msg));
}

void botInfo::sendTeam(BYTE snd, char *msg)
{
	tell(makeSay(MSG_Team, snd, 0, msg));
}

void botInfo::sendTeamPrivate(Uint16 team, char *msg)
{
	tell(makeSay(MSG_TeamPrivate, 0, team, msg));
}

void botInfo::sendTeamPrivate(Uint16 team, BYTE snd, char *msg)
{
	tell(makeSay(MSG_TeamPrivate, snd, team, msg));
}

void botInfo::sendPublic(char *msg)
{
	tell(makeSay(MSG_Public, 0, 0, msg));
}

void botInfo::sendPublic(BYTE snd, char *msg)
{
	tell(makeSay(MSG_Public, snd, 0, msg));
}

void botInfo::sendPublicMacro(char *msg)
{
	tell(makeSay(MSG_PublicMacro, 0, 0, msg));
}

void botInfo::sendPublicMacro(BYTE snd, char *msg)
{
	tell(makeSay(MSG_PublicMacro, snd, 0, msg));
}

void botInfo::sendChannel(char *msg)
{
	tell(makeSay(MSG_Channel, 0, 0, msg));
}

void botInfo::sendRemotePrivate(char *msg)
{
	tell(makeSay(MSG_RemotePrivate, 0, 0, msg));
}

void botInfo::sendRemotePrivate(char *name, char *msg)
{
	String s;
	s += ":";
	s += name;
	s += ":";
	s += msg;

	sendRemotePrivate(s);
}
